/************************************************/
/*						*/
/*      Copyright:				*/
/*	 Jean-Marc Pigeon <jmp@safe.ca>	 2009	*/
/*						*/
/************************************************/
/* This program is free software; you can 	*/
/* redistribute it and/or modify it under the 	*/
/* terms of the GNU General Public License as	*/
/* published by the Free Software Foundation	*/
/* version 2 of the License			*/
/*						*/
/* This program is distributed in the hope that */
/* it will be useful, but WITHOUT ANY WARRANTY; */
/* without even the implied warranty of		*/
/* MERCHANTABILITY or FITNESS FOR A PARTICULAR	*/
/* PURPOSE.  See the GNU General Public License	*/
/* for more details.				*/
/*						*/
/* You should have received a copy of the GNU	*/
/* General Public License along with this 	*/
/* program; if not, write to the Free Software	*/
/* Foundation, Inc., 51 Franklin Street,	*/
/* Fifth Floor, Boston, MA  02110-1301, USA.	*/
/************************************************/
/*						*/
/*	INITDOM:				*/
/*	Program to manage local domain.		*/
/*	it take care of both the directory	*/
/*	creation and user passwd management	*/
/*	and the aliases lits too.		*/
/*						*/
/*						*/
/*	Obsolete, April 2006			*/
/*						*/
/************************************************/
#include	<stdlib.h>
#include	<unistd.h>
#include	<string.h>
#include	<getopt.h>
#include	<syslog.h>
#include	"subrou.h"
#include	"gesque.h"

#define	INITDOM	"initdom"

static VOCTYP vocinfo[]={
		{m_add,"add",(const void *)0},
		{m_rem,"rem",(const void *)0},
		{m_del,"del",(const void *)0},
		{m_unk,(const char *)0,(const void *)0}
		};

/*

*/
/************************************************/
/*						*/
/*	Procedure to display the program usage	*/
/*						*/
/************************************************/
static void usage()

{
(void) fprintf(stderr,"%s Version %s\n",appname,rou_getvers());
(void) fprintf(stderr,"usage:  %s "
		      "[-a ] "
		      "[-b base] "
		      "[-d debug] "
		      "[-h ] "
		      "add|rem domain username crypted_passe\n",
		       appname);
(void) fprintf(stderr,"\t\t-a        : E-mail alias management mode\n");
(void) fprintf(stderr,"\t\t-b base   : application working directory\n");
(void) fprintf(stderr,"\t\t-d debug  : debug level\n");
(void) fprintf(stderr,"\t\t-h        : display usage\n");
(void) exit(-1);
}
/*

*/
/************************************************/
/*						*/
/*	Procedure to request an Email creation	*/
/*	or update.				*/
/*						*/
/************************************************/
static int mngemail(MNGTYP code,char *domain,char *usrid,
		    char *passwd,char *name)

{
int done;
PASTYP *pi;
char line[400];

done=false;
(void) snprintf(line,sizeof(line),"%s %s %s '%s'",domain,usrid,passwd,name);
if ((pi=que_getusrinfo(line))!=(PASTYP *)0) {
  done=que_mngemails(code,pi);
  pi=que_freeusrinfo(pi);
  }
return done;
}
/*

*/
/************************************************/
/*						*/
/*	Main Program				*/
/*						*/
/************************************************/
int main(int argc,char *argv[])

{
char c;
int parmis;
int aliasmod;
char *basenom;
char curpath[200];

appname=INITDOM;
base=strdup(base);

parmis=true;
aliasmod=false;
(void) strncpy(curpath,argv[0],sizeof(curpath));
if ((basenom=strrchr(curpath,'/'))==(char *)0)
  basenom=curpath;
else
  basenom++;
(void) openlog(appname,LOG_PID,0);
while ((c=getopt(argc,argv,"b:d:h:v"))!=EOF) {
  switch(c) {
    case   'a'  :
      aliasmod=true;
      break;
    case   'b'  :
      (void) free(base);
      base=strdup(optarg);
      break;
    case   'd'  :
      debug=atoi(optarg);
      break;
    case   'v'  :
      verbose=true;
      break;
    case   'h'  :
    default     :
      (void) usage();
      break;
    }
  }
if ((argc-optind)>=2) {
  MNGTYP code;

  code=(MNGTYP)(rou_getvoca(vocinfo,argv[optind])->code);
  switch (code)  {
    case m_add		:
    case m_rem		:
      if ((argc-optind)>=4) {
	parmis=false;
        switch (aliasmod) {
	  case true	:
	    /*mngemail(strcode,domain,userid,cryptedpasswd,name);	*/
            if ( mngemails(code,argv[optind+1],argv[optind+2],
				argv[optind+3],argv[optind+4])!=true) {
	      char *ptr;

	      ptr=argv[optind];
              (void) fprintf(stderr,"Unable to execute initdom command <"
			            "%s %s %s %s %s>\n",
				    ptr,ptr+1,ptr+2,ptr+3,ptr+4);
	      }
	    break;
	  case false	:
	    /*que_mngaliases(code,domain,name,alias);	*/
            (void) que_mngaliases(code,argv[optind+1],argv[optind+2],
				       argv[optind+3]);
	    break;
	  }
        }
          if ((argc-optind)==4) {
	    parmis=false;
	  break;
          if ((argc-optind)==4) {
	    parmis=false;
            (void) que_mngemails(code,argv[optind+1],
				      argv[optind+2],argv[optind+3]);
	    }
	  break;
        }
      break;
    case m_del		:
      (void) que_deldom(argv[optind+1]);
      break;
    default		:
      (void) fprintf(stderr,"<%s> Unexpected directive (see %s -h)\n",
			    argv[optind],appname);
      break;
    }
  }
if (parmis==true) {
  (void) fprintf(stderr,"paramenters are missing (see %s -h)\n",appname);
  }
base=rou_freestr(base);
return 0;
}
