#! /bin/sh
#-----------------------------------------------------------------
#Shell script to add in various mail configuration file
#-----------------------------------------------------------------
base=$1

START=$APPNAME" START"
STOP=$APPNAME" STOP"

#--------------------------------------------------------------------
#empty file
for mailer in "exim" "postfix" "sendmail" 
  do
  case "$mailer" in
    "exim" )
      cat > $base/conf.released/exim.cf <<!EOT
#$START
#Lines need to be added to /etc/exim.conf file BEGINING
#--------------------------------------------------------------------
#opening a listening daemon port on 127.0.0.1 and 127.0.0.25 for clement request
#--------------------------------------------------------------------
local_interfaces= 127.0.0.1:127.0.0.25
#remove message recurring limitation on interface used by clement
hostlist clement = 127.0.0.1:127.0.0.25
smtp_accept_max_nonmail_hosts = ! +clement : *
smtp_accept_max_per_connection = 0
smtp_accept_queue_per_connection = 0
#$STOP
!EOT
      ;;
#updating postfix config
    "postfix" )
      cat > $base/conf.released/master.cf <<!EOT
#$START
#Lines need to be added to /etc/postfix/master.cf file ENDING
#--------------------------------------------------------------------
#opening a listening daemon port on 127.0.0.25 for clement request
localmail:smtp     inet  n       -       n       -       -       smtpd
#--------------------------------------------------------------------
#$STOP
!EOT
      ;;
#updating sendmail config file
    "sendmail"| \
    *)
      cat > $base/conf.released/sendmail.cf <<!EOT
#$START
#Lines need to be added to /etc/mail/sendmail.cf file ENDING
#--------------------------------------------------------------------
#opening a listening daemon on 127.0.0.25 for clement request
O DaemonPortOptions=Port=smtp,Addr=127.0.0.25, Name=MTA
#--------------------------------------------------------------------
#$STOP
!EOT
      ;;
  esac
done

